//
//  Authorization.h
//  Authorization
//
//  Created by ed on Wed Nov 14 2001.
//  Copyright (c) 2001 Septicus Software. All rights reserved.
//  $Author: ed $
//  $Id: Authorization.h,v 1.4 2002/04/06 22:55:37 ed Exp $
//  $Date: 2002/04/06 22:55:37 $
//  $Name:  $
//  $Revision: 1.4 $
//  $Log: Authorization.h,v $
//  Revision 1.4  2002/04/06 22:55:37  ed
//  added copyright for Septicus Software...
//
//  Revision 1.3  2002/03/23 17:24:48  ed
//  changed getToolPath to toolPath, changed includes to use Cocoa.h, not just Foundation.h
//
//  Revision 1.2  2002/02/08 18:19:24  ed
//  fixed a typo...
//
//  Revision 1.1.1.1  2002/02/08 18:15:40  ed
//  putting Authorization code into CVS
//
//  Description: Provides a Cocoa Object wrapper around Security Framework...
//

#import <Cocoa/Cocoa.h>
#import <Security/Authorization.h>
#import <Security/AuthorizationTags.h>

@interface Authorization : NSObject {
    @private
        // auth framework...
        AuthorizationRef authRef;
    @protected
        // if running a tool...
        NSString *toolPath;
}

-(void)dealloc;

// set up authRef...
- (id)init;
- (id)initWithToolPath:(NSString *)tool;

-(void)setToolPath:(NSString *)tool;
-(NSString *)toolPath;

// run a tool with authorization...
-(int)runAuthenticated:(char **)arg;
-(int)runToolAuthenticated:(NSString *)tool args:(char **)arg;

// clear authorization...
- (void)clearAuthRef;

// auth check...
- (BOOL)isAuthenticated;

// perform authorization...
- (BOOL)authenticate;

// undo authorization...
- (void)deauthenticate;

// get the password...
- (BOOL)fetchPassword;

@end
